/*********************************************************************
*                                                                    *
*                SEGGER Microcontroller GmbH & Co. KG                *
*        Solutions for real time microcontroller applications        *
*                                                                    *
**********************************************************************
*                                                                    *
* C-file generated by:                                               *
*                                                                    *
*        GUI_Builder for emWin version 5.40                          *
*        Compiled Jun 22 2017, 10:13:26                              *
*        (c) 2017 Segger Microcontroller GmbH & Co. KG               *
*                                                                    *
**********************************************************************
*                                                                    *
*        Internet: www.segger.com  Support: support@segger.com       *
*                                                                    *
**********************************************************************
*/

// USER START (Optionally insert additional includes)
// USER END

#include "DIALOG.h"

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
#define ID_WINDOW_0     (GUI_ID_USER + 0x00)
#define ID_IMAGE_0     (GUI_ID_USER + 0x01)


// USER START (Optionally insert additional defines)
// USER END

/*********************************************************************
*
*       Static data
*
**********************************************************************
*/

// USER START (Optionally insert additional static data)
extern GUI_CONST_STORAGE GUI_BITMAP bmImage;	// From "Image.c"
SCROLLBAR_Handle hScrollbar;					// Scrollbar handler;
// USER END

/*********************************************************************
*
*       _aDialogCreate
*/
static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = {
  { WINDOW_CreateIndirect, "WindowImgScroll", ID_WINDOW_0, 0, 0, 320, 240, 0, 0x0, 0 },
  { IMAGE_CreateIndirect, "Image", ID_IMAGE_0, 112, 36, 70, 100, 0, 0, 1 },
  // USER START (Optionally insert additional widgets)
  // USER END
};

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/

// USER START (Optionally insert additional static code)

// Callback function for the IMAGE widget
static void _cbImage(WM_MESSAGE * pMsg) {
	int MsgId;	// Message Id
	U8 Val;		// Scrollbar value
	
	switch (pMsg->MsgId) {
	case WM_NOTIFY_PARENT:								
		MsgId = pMsg->Data.v;
		
		// If scrollbar notifies its parent window (IMAGE) of changing its value
		if ((pMsg->hWinSrc == hScrollbar) && (MsgId == WM_NOTIFICATION_VALUE_CHANGED))
		{
			WM_Invalidate(pMsg->hWin);					// and invalidate for calling WM_PAINT
		}
		break;
	case WM_PAINT:
		Val = SCROLLBAR_GetValue(hScrollbar);		// Get the scrollbar value
		if (Val != 0)									// If scrollbar position != 0
			GUI_DrawBitmap(&bmImage, 0, -1.12 * Val);	// Change the image position according to the value 											// so you need to correct it for your own image and scrollbar
		else
			GUI_DrawBitmap(&bmImage, 0, 0);				// If scrollbar position == 0 then draw image at default position		
		break;
	default:
		IMAGE_Callback(pMsg);							
		break;
	}
}
// USER END

/*********************************************************************
*
*       _cbDialog
*/
static void _cbDialog(WM_MESSAGE * pMsg) {
  WM_HWIN hItem;
  // USER START (Optionally insert additional variables)
  // USER END

  switch (pMsg->MsgId) {
  case WM_INIT_DIALOG:
    //
    // Initialization of 'WindowImgScroll'
    //
    hItem = pMsg->hWin;
    WINDOW_SetBkColor(hItem, GUI_MAKE_COLOR(0x00F8AC8F));
    // USER START (Optionally insert additional code for further widget initialization)
	hItem = WM_GetDialogItem(pMsg->hWin, ID_IMAGE_0);						// Get the IMAGE widget handler
	IMAGE_SetBitmap(hItem, &bmImage);										// Set the bitmap for the IMAGE widget

	hScrollbar = SCROLLBAR_CreateAttached(hItem, SCROLLBAR_CF_VERTICAL);	// Create a scrollbar attached to the IMAGE widget
	WM_SetCallback(hItem, _cbImage);										// Set a callback function for handling the scrollbar position
    // USER END
    break;
  // USER START (Optionally insert additional message handling)
  // USER END
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       CreateWindowImgScroll
*/
WM_HWIN CreateWindowImgScroll(void);
WM_HWIN CreateWindowImgScroll(void) {
  WM_HWIN hWin;

  hWin = GUI_CreateDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), _cbDialog, WM_HBKWIN, 0, 0);
  return hWin;
}

// USER START (Optionally insert additional public code)
// USER END

/*************************** End of file ****************************/
